diff -r 73af8be8415d trytond/modules/product/tests/test_product.py
--- a/trytond/modules/product/tests/test_product.py	Thu Aug 23 23:18:16 2012 +0200
+++ b/trytond/modules/product/tests/test_product.py	Mon Sep 24 20:36:41 2012 +0200
@@ -45,41 +45,41 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            category_id = self.uom_category.create({'name': 'Test'})
+            category = self.uom_category.create({'name': 'Test'})
             transaction.cursor.commit()
 
-            self.failUnlessRaises(Exception, self.uom.create, {
-                'name': 'Test',
-                'symbol': 'T',
-                'category': category_id,
-                'rate': 0,
-                'factor': 0,
-                })
+            self.assertRaises(Exception, self.uom.create, {
+                    'name': 'Test',
+                    'symbol': 'T',
+                    'category': category.id,
+                    'rate': 0,
+                    'factor': 0,
+                    })
             transaction.cursor.rollback()
 
-            uom_id = self.uom.create({
-                'name': 'Test',
-                'symbol': 'T',
-                'category': category_id,
-                'rate': 1.0,
-                'factor': 1.0,
-                })
+            uom = self.uom.create({
+                    'name': 'Test',
+                    'symbol': 'T',
+                    'category': category.id,
+                    'rate': 1.0,
+                    'factor': 1.0,
+                    })
             transaction.cursor.commit()
 
-            self.failUnlessRaises(Exception, self.uom.write, uom_id, {
-                'rate': 0.0,
-                })
+            self.assertRaises(Exception, self.uom.write, [uom], {
+                    'rate': 0.0,
+                    })
             transaction.cursor.rollback()
 
-            self.failUnlessRaises(Exception, self.uom.write, uom_id, {
-                'factor': 0.0,
-                })
+            self.assertRaises(Exception, self.uom.write, [uom], {
+                    'factor': 0.0,
+                    })
             transaction.cursor.rollback()
 
-            self.failUnlessRaises(Exception, self.uom.write, uom_id, {
-                'rate': 0.0,
-                'factor': 0.0,
-                })
+            self.assertRaises(Exception, self.uom.write, [uom], {
+                    'rate': 0.0,
+                    'factor': 0.0,
+                    })
             transaction.cursor.rollback()
 
     def test0020uom_check_factor_and_rate(self):
@@ -88,33 +88,33 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            category_id = self.uom_category.search([
-                ('name', '=', 'Test'),
-                ], limit=1)[0]
+            category, = self.uom_category.search([
+                    ('name', '=', 'Test'),
+                    ], limit=1)
 
-            self.failUnlessRaises(Exception, self.uom.create, {
-                'name': 'Test',
-                'symbol': 'T',
-                'category': category_id,
-                'rate': 2,
-                'factor': 2,
-                })
+            self.assertRaises(Exception, self.uom.create, {
+                    'name': 'Test',
+                    'symbol': 'T',
+                    'category': category.id,
+                    'rate': 2,
+                    'factor': 2,
+                    })
             transaction.cursor.rollback()
 
-            uom_id = self.uom.search([
-                ('name', '=', 'Test'),
-                ], limit=1)[0]
+            uom, = self.uom.search([
+                    ('name', '=', 'Test'),
+                    ], limit=1)
 
-            self.failUnlessRaises(Exception, self.uom.write, uom_id,
-                    {
-                        'rate': 2.0,
-                        })
+            self.assertRaises(Exception, self.uom.write, [uom],
+                {
+                    'rate': 2.0,
+                    })
             transaction.cursor.rollback()
 
-            self.failUnlessRaises(Exception, self.uom.write, uom_id,
-                    {
-                        'factor': 2.0,
-                        })
+            self.assertRaises(Exception, self.uom.write, [uom],
+                {
+                    'factor': 2.0,
+                    })
             transaction.cursor.rollback()
 
     def test0030uom_select_accurate_field(self):
@@ -126,14 +126,13 @@
             ('Kilometer', 'factor'),
             ('centimeter', 'rate'),
             ('Foot', 'factor'),
-        ]
+            ]
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
             for name, result in tests:
-                uom_id = self.uom.search([
-                    ('name', '=', name),
-                    ], limit=1)[0]
-                uom = self.uom.browse(uom_id)
-                self.assert_(result == self.uom.select_accurate_field(uom))
+                uom, = self.uom.search([
+                        ('name', '=', name),
+                        ], limit=1)
+                self.assertEqual(result, uom.accurate_field)
 
     def test0040uom_compute_qty(self):
         '''
@@ -145,28 +144,28 @@
             ('Second', 5, 'Minute', 0.083333333333333343, 0.08),
             ('Second', 25, 'Hour', 0.0069444444444444441, 0.01),
             ('Millimeter', 3, 'Inch', 0.11811023622047245, 0.12),
-        ]
+            ]
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
             for from_name, qty, to_name, result, rounded_result in tests:
-                from_uom = self.uom.browse(self.uom.search(
-                    [
-                     ('name', '=', from_name),
-                    ], limit=1)[0])
-                to_uom = self.uom.browse(self.uom.search(
-                    [
+                from_uom, = self.uom.search([
+                        ('name', '=', from_name),
+                        ], limit=1)
+                to_uom, = self.uom.search([
                         ('name', '=', to_name),
-                    ], limit=1)[0])
-                self.assert_(result == self.uom.compute_qty(from_uom,
-                    qty, to_uom, False))
-                self.assert_(rounded_result == self.uom.compute_qty(
-                    from_uom, qty, to_uom, True))
+                        ], limit=1)
+                self.assertEqual(result, self.uom.compute_qty(from_uom,
+                        qty, to_uom, False))
+                self.assertEqual(rounded_result, self.uom.compute_qty(
+                        from_uom, qty, to_uom, True))
 
-            self.assert_(10 == self.uom.compute_qty(None, 10, to_uom))
-            self.assert_(10 == self.uom.compute_qty(None, 10, to_uom, True))
-            self.assert_(0 == self.uom.compute_qty(from_uom, 0, to_uom))
-            self.assert_(0 == self.uom.compute_qty(from_uom, 0, to_uom, True))
-            self.assert_(10 == self.uom.compute_qty(from_uom, 10, None))
-            self.assert_(10 == self.uom.compute_qty(from_uom, 10, None, True))
+            self.assertEqual(10, self.uom.compute_qty(None, 10, to_uom))
+            self.assertEqual(10, self.uom.compute_qty(None, 10, to_uom, True))
+            self.assertEqual(0, self.uom.compute_qty(from_uom, 0, to_uom))
+            self.assertEqual(0,
+                self.uom.compute_qty(from_uom, 0, to_uom, True))
+            self.assertEqual(10, self.uom.compute_qty(from_uom, 10, None))
+            self.assertEqual(10,
+                self.uom.compute_qty(from_uom, 10, None, True))
 
     def test0050uom_compute_price(self):
         '''
@@ -178,19 +177,17 @@
             ('Second', Decimal('5'), 'Minute', Decimal('300')),
             ('Second', Decimal('25'), 'Hour', Decimal('90000')),
             ('Millimeter', Decimal('3'), 'Inch', Decimal('76.2')),
-        ]
+            ]
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
             for from_name, price, to_name, result in tests:
-                from_uom = self.uom.browse(self.uom.search(
-                    [
+                from_uom, = self.uom.search([
                         ('name', '=', from_name),
-                    ], limit=1)[0])
-                to_uom = self.uom.browse(self.uom.search(
-                    [
+                        ], limit=1)
+                to_uom, = self.uom.search([
                         ('name', '=', to_name),
-                    ], limit=1)[0])
-                self.assert_(result == self.uom.compute_price(from_uom,
-                    price, to_uom))
+                        ], limit=1)
+                self.assertEqual(result, self.uom.compute_price(from_uom,
+                        price, to_uom))
 
 
 def suite():
diff -r 73af8be8415d trytond/modules/product/uom.py
--- a/trytond/modules/product/uom.py	Thu Aug 23 23:18:16 2012 +0200
+++ b/trytond/modules/product/uom.py	Mon Sep 24 20:36:41 2012 +0200
@@ -5,6 +5,8 @@
 from trytond.pyson import Eval
 from trytond.transaction import Transaction
 
+__all__ = ['UomCategory', 'Uom']
+
 STATES = {
     'readonly': ~Eval('active', True),
     }
@@ -13,22 +15,19 @@
 
 class UomCategory(ModelSQL, ModelView):
     'Product uom category'
-    _name = 'product.uom.category'
-    _description = __doc__
+    __name__ = 'product.uom.category'
     name = fields.Char('Name', required=True, translate=True)
     uoms = fields.One2Many('product.uom', 'category', 'Unit of Measures')
 
-    def __init__(self):
-        super(UomCategory, self).__init__()
-        self._order.insert(0, ('name', 'ASC'))
-
-UomCategory()
+    @classmethod
+    def __setup__(cls):
+        super(UomCategory, cls).__setup__()
+        cls._order.insert(0, ('name', 'ASC'))
 
 
 class Uom(ModelSQL, ModelView):
     'Unit of measure'
-    _name = 'product.uom'
-    _description = __doc__
+    __name__ = 'product.uom'
     name = fields.Char('Name', size=None, required=True, states=STATES,
         translate=True, depends=DEPENDS)
     symbol = fields.Char('Symbol', size=10, required=True, states=STATES,
@@ -48,183 +47,186 @@
     digits = fields.Integer('Display Digits', required=True)
     active = fields.Boolean('Active')
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.6: corrected misspelling of ounce (was once)
         cursor.execute("UPDATE ir_model_data "\
                 "SET fs_id = REPLACE(fs_id, 'uom_once', 'uom_ounce') "\
                 "WHERE fs_id = 'uom_once' AND module = 'product'")
-        super(Uom, self).init(module_name)
+        super(Uom, cls).__register__(module_name)
 
-    def __init__(self):
-        super(Uom, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Uom, cls).__setup__()
+        cls._sql_constraints += [
             ('non_zero_rate_factor', 'CHECK((rate != 0.0) or (factor != 0.0))',
                 'Rate and factor can not be both equal to zero.')
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_factor_and_rate', 'invalid_factor_and_rate'),
-        ]
-        self._order.insert(0, ('name', 'ASC'))
-        self._error_messages.update({
-                'change_uom_rate_title': 'You cannot change Rate, Factor or '
+            ]
+        cls._order.insert(0, ('name', 'ASC'))
+        cls._error_messages.update({
+                'change_uom_rate_title': 'You cannot change Rate, Factor or ' \
                     'Category on a Unit of Measure. ',
-                'change_uom_rate': 'If the UOM is still not used, you can '
-                    'delete it otherwise you can deactivate it '
+                'change_uom_rate': 'If the UOM is still not used, you can ' \
+                    'delete it otherwise you can deactivate it ' \
                     'and create a new one.',
                 'invalid_factor_and_rate': 'Invalid Factor and Rate values!',
-            })
+                })
 
-    def check_xml_record(self, ids, values):
+    @classmethod
+    def __post_setup__(cls):
+        super(Uom, cls).__post_setup__()
+        if 'category' not in cls._fields:
+            print cls, cls._fields
+
+    @classmethod
+    def check_xml_record(cls, records, values):
         return True
 
-    def default_rate(self):
+    @staticmethod
+    def default_rate():
         return 1.0
 
-    def default_factor(self):
+    @staticmethod
+    def default_factor():
         return 1.0
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_rounding(self):
+    @staticmethod
+    def default_rounding():
         return 0.01
 
-    def default_digits(self):
+    @staticmethod
+    def default_digits():
         return 2
 
-    def on_change_factor(self, value):
-        if value.get('factor', 0.0) == 0.0:
+    def on_change_factor(self):
+        if (self.factor or 0.0) == 0.0:
             return {'rate': 0.0}
-        return {'rate': round(1.0 / value['factor'], self.rate.digits[1])}
+        return {
+            'rate': round(1.0 / self.factor, self.__class__.rate.digits[1]),
+            }
 
-    def on_change_rate(self, value):
-        if value.get('rate', 0.0) == 0.0:
+    def on_change_rate(self):
+        if (self.rate or 0.0) == 0.0:
             return {'factor': 0.0}
-        return {'factor': round(1.0 / value['rate'], self.factor.digits[1])}
+        return {
+            'factor': round(1.0 / self.rate, self.__class__.factor.digits[1]),
+            }
 
-    def search_rec_name(self, name, clause):
-        ids = self.search(['OR',
-            (self._rec_name,) + clause[1:],
-            ('symbol',) + clause[1:],
-            ], order=[])
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        ids = map(int, cls.search(['OR',
+                    (cls._rec_name,) + clause[1:],
+                    ('symbol',) + clause[1:],
+                    ], order=[]))
         return [('id', 'in', ids)]
 
     @staticmethod
     def round(number, precision=1.0):
         return round(number / precision) * precision
 
-    def check_factor_and_rate(self, ids):
+    def check_factor_and_rate(self):
         "Check coherence between factor and rate"
-        for uom in self.browse(ids):
-            if uom.rate == uom.factor == 0.0:
-                continue
-            if uom.rate != round(1.0 / uom.factor, self.rate.digits[1]) and \
-                    uom.factor != round(1.0 / uom.rate, self.factor.digits[1]):
-                return False
+        if self.rate == self.factor == 0.0:
+            return True
+        if (self.rate != round(
+                    1.0 / self.factor, self.__class__.rate.digits[1])
+                and self.factor != round(
+                    1.0 / self.rate, self.__class__.factor.digits[1])):
+            return False
         return True
 
-    def write(self, ids, values):
+    @classmethod
+    def write(cls, uoms, values):
         if Transaction().user == 0:
-            return super(Uom, self).write(ids, values)
+            return super(Uom, cls).write(uoms, values)
         if 'rate' not in values and 'factor' not in values \
                 and 'category' not in values:
-            return super(Uom, self).write(ids, values)
+            super(Uom, cls).write(uoms, values)
+            return
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
-        uoms = self.browse(ids)
         old_uom = dict((uom.id, (uom.factor, uom.rate, uom.category.id)) \
                            for uom in uoms)
 
-        res = super(Uom, self).write(ids, values)
-        uoms = self.browse(ids)
+        super(Uom, cls).write(uoms, values)
 
         for uom in uoms:
             if uom.factor != old_uom[uom.id][0] \
                     or uom.rate != old_uom[uom.id][1] \
                     or uom.category.id != old_uom[uom.id][2]:
 
-                self.raise_user_error('change_uom_rate_title',
-                        error_description='change_uom_rate')
-        return res
+                cls.raise_user_error('change_uom_rate_title',
+                    error_description='change_uom_rate')
 
-    def select_accurate_field(self, uom):
+    @property
+    def accurate_field(self):
         """
         Select the more accurate field.
         It chooses the field that has the least decimal.
-
-        :param uom: a BrowseRecord of UOM.
-        :return: 'factor' or 'rate'.
         """
         lengths = {}
         for field in ('rate', 'factor'):
-            format = '%%.%df' % getattr(self, field).digits[1]
-            lengths[field] = len((format % getattr(uom,
-                field)).split('.')[1].rstrip('0'))
+            format = '%%.%df' % getattr(self.__class__, field).digits[1]
+            lengths[field] = len((format % getattr(self,
+                        field)).split('.')[1].rstrip('0'))
         if lengths['rate'] < lengths['factor']:
             return 'rate'
         elif lengths['factor'] < lengths['rate']:
             return 'factor'
-        elif uom.factor >= 1.0:
+        elif self.factor >= 1.0:
             return 'factor'
         else:
             return 'rate'
 
-    def compute_qty(self, from_uom, qty, to_uom=None, round=True):
+    @classmethod
+    def compute_qty(cls, from_uom, qty, to_uom=None, round=True):
         """
         Convert quantity for given uom's.
-
-        :param from_uom: a BrowseRecord of product.uom
-        :param qty: an int or long or float value
-        :param to_uom: a BrowseRecord of product.uom
-        :param round: a boolean to round or not the result
-        :return: the converted quantity
         """
         if not from_uom or not qty or not to_uom:
             return qty
         if from_uom.category.id != to_uom.category.id:
             return qty
-        if self.select_accurate_field(from_uom) == 'factor':
+        if from_uom.accurate_field == 'factor':
             amount = qty * from_uom.factor
         else:
             amount = qty / from_uom.rate
         if to_uom is not None:
-            if self.select_accurate_field(to_uom) == 'factor':
+            if to_uom.accurate_field == 'factor':
                 amount = amount / to_uom.factor
             else:
                 amount = amount * to_uom.rate
             if round:
-                amount = self.round(amount, to_uom.rounding)
+                amount = cls.round(amount, to_uom.rounding)
         return amount
 
-    def compute_price(self, from_uom, price, to_uom=None):
+    @classmethod
+    def compute_price(cls, from_uom, price, to_uom=None):
         """
         Convert price for given uom's.
-
-        :param from_uom: a BrowseRecord of product.uom
-        :param price: a Decimal value
-        :param to_uom: a BrowseRecord of product.uom
-        :return: the converted price
         """
         if not from_uom or not price or not to_uom:
             return price
         if from_uom.category.id != to_uom.category.id:
             return price
-        factor_format = '%%.%df' % self.factor.digits[1]
-        rate_format = '%%.%df' % self.rate.digits[1]
+        factor_format = '%%.%df' % cls.factor.digits[1]
+        rate_format = '%%.%df' % cls.rate.digits[1]
 
-        if self.select_accurate_field(from_uom) == 'factor':
+        if from_uom.accurate_field == 'factor':
             new_price = price / Decimal(factor_format % from_uom.factor)
         else:
             new_price = price * Decimal(rate_format % from_uom.rate)
 
-        if self.select_accurate_field(to_uom) == 'factor':
+        if to_uom.accurate_field == 'factor':
             new_price = new_price * Decimal(factor_format % to_uom.factor)
         else:
             new_price = new_price / Decimal(rate_format % to_uom.rate)
 
         return new_price
-
-Uom()
diff -r 69c543cd85c6 trytond/modules/product_cost_fifo/__init__.py
--- a/trytond/modules/product_cost_fifo/__init__.py	Fri Jun 08 19:34:09 2012 +0200
+++ b/trytond/modules/product_cost_fifo/__init__.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,5 +1,12 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-
+from trytond.pool import Pool
 from .product import *
 from .move import *
+
+
+def register():
+    Pool.register(
+        Template,
+        Move,
+        module='product_cost_fifo', type_='model')
diff -r 69c543cd85c6 trytond/modules/product_cost_fifo/move.py
--- a/trytond/modules/product_cost_fifo/move.py	Fri Jun 08 19:34:09 2012 +0200
+++ b/trytond/modules/product_cost_fifo/move.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,73 +1,69 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 from decimal import Decimal
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import fields
 from trytond.pyson import Eval
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Move']
+__metaclass__ = PoolMeta
 
-class Move(ModelSQL, ModelView):
-    _name = 'stock.move'
+
+class Move:
+    __name__ = 'stock.move'
     fifo_quantity = fields.Float('FIFO Quantity',
         digits=(16, Eval('unit_digits', 2)),
         depends=['unit_digits'])
 
-    def __init__(self):
-        super(Move, self).__init__()
-        self._sql_constraints += [
-            ('check_fifo_quantity_out',
-                'CHECK(quantity >= fifo_quantity)',
-                'FIFO quantity can not be greater than quantity!'),
-        ]
-        self._error_messages.update({
-            'del_move_fifo': 'You can not delete move that is used ' \
+    @classmethod
+    def __setup__(cls):
+        super(Move, cls).__setup__()
+        cls._sql_constraints += [
+                ('check_fifo_quantity_out',
+                    'CHECK(quantity >= fifo_quantity)',
+                    'FIFO quantity can not be greater than quantity!'),
+                ]
+        cls._error_messages.update({
+                'del_move_fifo': 'You can not delete move that is used '\
                     'for FIFO cost price!',
-            })
+                })
 
-    def default_fifo_quantity(self):
+    @staticmethod
+    def default_fifo_quantity():
         return 0.0
 
-    def _update_fifo_out_product_cost_price(self, product, quantity, uom,
+    @classmethod
+    def _update_fifo_out_product_cost_price(cls, product, quantity, uom,
             date):
         '''
         Update the product cost price of the given product. Update
         fifo_quantity on the concerned incomming moves. Return the
         cost price for outputing the given product and quantity.
-
-        :param product: a BrowseRecord of the product
-        :param quantity: the quantity of the outgoing product
-        :param uom: the uom id or a BrowseRecord of the uom
-        :param date: the date for the currency rate calculation
-        :return: cost_price (of type decimal)
         '''
 
-        template_obj = Pool().get('product.template')
-        uom_obj = Pool().get('product.uom')
+        Uom = Pool().get('product.uom')
 
-        if isinstance(uom, (int, long)):
-            uom = uom_obj.browse(uom)
-
-        total_qty = uom_obj.compute_qty(uom, quantity, product.default_uom,
+        total_qty = Uom.compute_qty(uom, quantity, product.default_uom,
                 round=False)
 
-        fifo_moves = template_obj.get_fifo_move(product.template.id, total_qty)
+        fifo_moves = product.template.get_fifo_move(total_qty)
 
         cost_price = Decimal("0.0")
         consumed_qty = 0.0
         for move, move_qty in fifo_moves:
             consumed_qty += move_qty
 
-            move_unit_price = uom_obj.compute_price(move.uom, move.unit_price,
+            move_unit_price = Uom.compute_price(move.uom, move.unit_price,
                     move.product.default_uom)
             cost_price += move_unit_price * Decimal(str(move_qty))
 
-            self._update_product_cost_price(product.id, -move_qty,
+            cls._update_product_cost_price(product.id, -move_qty,
                     product.default_uom, move_unit_price, move.currency,
                     move.company, date)
 
-            move_qty = uom_obj.compute_qty(product.default_uom, move_qty,
+            move_qty = Uom.compute_qty(product.default_uom, move_qty,
                     move.uom, round=False)
-            self.write(move.id, {
+            cls.write([move], {
                 'fifo_quantity': (move.fifo_quantity or 0.0) + move_qty,
                 })
 
@@ -75,71 +71,71 @@
             cost_price = cost_price / Decimal(str(consumed_qty))
 
         if cost_price != Decimal("0"):
-            digits = self.cost_price.digits
+            digits = cls.cost_price.digits
             return cost_price.quantize(
                 Decimal(str(10.0 ** -digits[1])))
         else:
             return product.cost_price
 
-    def create(self, vals):
+    @classmethod
+    def create(cls, vals):
         pool = Pool()
-        location_obj = pool.get('stock.location')
-        product_obj = pool.get('product.product')
-        date_obj = pool.get('ir.date')
+        Location = pool.get('stock.location')
+        Product = pool.get('product.product')
+        Date = pool.get('ir.date')
 
-        today = date_obj.today()
+        today = Date.today()
         effective_date = vals.get('effective_date') or today
 
         if vals.get('state') == 'done':
-            from_location = location_obj.browse(vals['from_location'])
-            to_location = location_obj.browse(vals['to_location'])
-            product = product_obj.browse(vals['product'])
+            from_location = Location(vals['from_location'])
+            to_location = Location(vals['to_location'])
+            product = Product(vals['product'])
             if (from_location.type in ('supplier', 'production')
                     and to_location.type == 'storage'
                     and product.cost_price_method == 'fifo'):
-                self._update_product_cost_price(vals['product'],
+                cls._update_product_cost_price(vals['product'],
                         vals['quantity'], vals['uom'], vals['unit_price'],
                         vals['currency'], effective_date)
             if (to_location.type == 'supplier'
                     and from_location.type == 'storage'
                     and product.cost_price_method == 'fifo'):
-                self._update_product_cost_price(vals['product'],
+                cls._update_product_cost_price(vals['product'],
                         -vals['quantity'], vals['uom'], vals['unit_price'],
                         vals['currency'], effective_date)
             if to_location.type != 'storage' \
                     and to_location.type != 'supplier' \
                     and product.cost_price_method == 'fifo':
 
-                cost_price = self._update_fifo_out_product_cost_price(product,
+                cost_price = cls._update_fifo_out_product_cost_price(product,
                         vals['quantity'], vals['uom'], effective_date)
                 if not vals.get('cost_price'):
                     vals['cost_price'] = cost_price
 
-        return super(Move, self).create(vals)
+        return super(Move, cls).create(vals)
 
-    def write(self, ids, vals):
-        date_obj = Pool().get('ir.date')
+    @classmethod
+    def write(cls, moves, vals):
+        Date = Pool().get('ir.date')
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        today = date_obj.today()
+        today = Date.today()
         effective_date = vals.get('effective_date') or today
 
         if 'state' in vals and vals['state'] == 'done':
-            for move in self.browse(ids):
+            for move in moves:
                 if vals['state'] == 'cancel':
                     if (move.from_location.type in ('supplier', 'production')
                             and move.to_location.type == 'storage'
                             and move.state != 'cancel'
                             and move.product.cost_price_method == 'fifo'):
-                        self._update_product_cost_price(move.product.id,
+                        cls._update_product_cost_price(move.product.id,
                                 -move.quantity, move.uom, move.unit_price,
                                 move.currency, move.company, effective_date)
                     if (move.to_location.type == 'supplier'
                             and move.from_location.type == 'storage'
                             and move.state != 'cancel'
                             and move.product.cost_price_method == 'fifo'):
-                        self._update_product_cost_price(move.product.id,
+                        cls._update_product_cost_price(move.product.id,
                                 move.quantity, move.uom, move.unit_price,
                                 move.currency, move.company, effective_date)
 
@@ -148,31 +144,31 @@
                             and move.to_location.type == 'storage'
                             and move.state != 'done'
                             and move.product.cost_price_method == 'fifo'):
-                        self._update_product_cost_price(move.product.id,
+                        cls._update_product_cost_price(move.product.id,
                                 move.quantity, move.uom, move.unit_price,
                                 move.currency, move.company, effective_date)
                     if (move.to_location.type == 'supplier'
                             and move.from_location.type == 'storage'
                             and move.state != 'done'
                             and move.product.cost_price_method == 'fifo'):
-                        self._update_product_cost_price(move.product.id,
+                        cls._update_product_cost_price(move.product.id,
                                 -move.quantity, move.uom, move.unit_price,
                                 move.currency, move.company, effective_date)
                     if move.to_location.type != 'storage' \
                             and move.to_location.type != 'supplier' \
                             and move.product.cost_price_method == 'fifo':
-                        cost_price = self._update_fifo_out_product_cost_price(
+                        cost_price = cls._update_fifo_out_product_cost_price(
                                 move.product, move.quantity, move.uom,
                                 effective_date)
                         if not vals.get('cost_price'):
                             vals['cost_price'] = cost_price
-        return super(Move, self).write(ids, vals)
+        super(Move, cls).write(moves, vals)
 
-    def delete(self, ids):
-        if self.search([
-            ('id', 'in', ids),
-            ('fifo_quantity', '!=', 0.0),
-            ]):
-            self.raise_user_error('del_move_fifo')
-        return super(Move, self).delete(ids)
-Move()
+    @classmethod
+    def delete(cls, moves):
+        if cls.search([
+                ('id', 'in', [m.id for m in moves]),
+                ('fifo_quantity', '!=', 0.0),
+                ]):
+            cls.raise_user_error('del_move_fifo')
+        super(Move, cls).delete(moves)
